clear all; clc
% written by Laurinne Balstad and Allison Shaw, Contact ashaw@umn.edu for assistance.

% ------------- MODEL PARAMETERS ---------------------------------------- %

N = 10; % How many bins
I0 = [1 2 3 4 5 6 7 8 9 10]; % These are the possible starting intensity classes --> this is a row
init = [1; 1; 1; 1; 1; 1; 1; 1; 1; 1]; % and how many individuals in each class at start --> note this is a column
t0vec = 0.01:0.05:0.96; % the time vector to be x axis
tRvec = 1-t0vec;
tauvec = 0.01:0.05:4.01; % the tau vector to be y axis
a_r = 0.376; % All these are the parameters
c_r = 0.9;
a_m = 0.665;
c_m = 0.53;
D = 5;
f_r = 1.1;
f_m = 2.02;
B_max = 2.5;
a1 = 0.9; % These are for density dep
a2 = 0.001;

% ------------- MODEL PARAMETERS ---------------------------------------- %

tic
M = []; % make a matrix that will hold information about what different dTvec/n combos evolve to be
for kind = 1:length(t0vec) % go through all the dTvec times
    t0vecval = t0vec(kind);
    tRvecval = tRvec(kind);
    for kind2 = 1:length(tauvec) % and all the n values
        tauval = tauvec(kind2);
        [theta_res] = findESS(N, I0, init, t0vecval, tRvecval, tauval, a_r, c_r, a_m, c_m, D, f_r, f_m, B_max, a1, a2);
        M(kind2, kind) = nansum(theta_res)/nnz(~isnan(theta_res)); %% this gives the prop of 1's to all thetas
    end
end
toc

disp('panel b')
t0 = 0.1; % the time vector to be x axis
tR = 1-t0;

ColMeansMat=[]; % this just lets us see what all the values are --> is like a checkpoint. Will store all the ESS combinations here
for kind = 1:length(t0) % go through all the dT times
    dTval = t0(kind);
    dT2val = tR(kind);
    for kind2 = 1:length(tauvec) % and all the n values
        tauval = tauvec(kind2);
        [theta_res] = findESS(N, I0, init, dTval, dT2val, tauval, a_r, c_r, a_m, c_m, D, f_r, f_m, B_max, a1, a2);
        ColMeansMat = [ColMeansMat; theta_res]; % put it into the history log of ESS values
    end
end
toc


save output_fig4.mat *

