clear all
% takes 16 minutes to run

% ------------- MODEL PARAMETERS ---------------------------------------- %

t0vec = 0.01:0.05:0.96; % the time vector to be x axis
tRvec = 1-t0vec; 
tauvec = 0.01:0.05:4.01; % the n vector to be y axis
a_r = 0.376; % All these are the parameters
c_r = 0.9;
a_m = 0.665;
c_m = 0.53;
D = 5;
f_r = 1.1;
f_m = 2.02;
B_max = 2.5;
a1 = 0.9; % These are for density dep
a2 = 0.001;

% ------------- MODEL PARAMETERS ---------------------------------------- %

tic
M5 = []; % make a matrix that will hold information about what different dTvec/n combos evolve to be
M7 = [];
M9 = [];
M12 = [];
for kind = 1:length(t0vec) % go through all the dTvec times
    t0vecval = t0vec(kind);
    tRvecval = tRvec(kind); 
    for kind2 = 1:length(tauvec) % and all the n values
        tauval = tauvec(kind2);
        
        if length(t0vecval)>1; error('t0val');end
        if length(tauval)>1; error('tauval');end
        
        [theta_res5] = findESS(5, [1 2 3 4 5], [1; 1; 1; 1; 1], t0vecval, tRvecval, tauval, a_r, c_r, a_m, c_m, D, f_r, f_m, B_max, a1, a2);
        [theta_res7] = findESS(7, [1 2 3 4 5 6 7], [1; 1; 1; 1; 1; 1; 1], t0vecval, tRvecval, tauval, a_r, c_r, a_m, c_m, D, f_r, f_m, B_max, a1, a2);
        [theta_res9] = findESS(9, [1 2 3 4 5 6 7 8 9], [1; 1; 1; 1; 1; 1; 1; 1; 1], t0vecval, tRvecval, tauval, a_r, c_r, a_m, c_m, D, f_r, f_m, B_max, a1, a2);
        [theta_res12] = findESS(12, [1 2 3 4 5 6 7 8 9 10 11 12], [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1], t0vecval, tRvecval, tauval, a_r, c_r, a_m, c_m, D, f_r, f_m, B_max, a1, a2);
        M5(kind2, kind) = nansum(theta_res5)/nnz(~isnan(theta_res5)); %% this gives the prop of 1's to all thetas
        M7(kind2, kind) = nansum(theta_res7)/nnz(~isnan(theta_res7));
        M9(kind2, kind) = nansum(theta_res9)/nnz(~isnan(theta_res9));
        M12(kind2, kind) = nansum(theta_res12)/nnz(~isnan(theta_res12));

    end
end
toc
save output_figS2.mat *
%%
clear all
load output_figS2.mat *
    f = 1; % these are scaling factors: should be at 1 here
    g = 1;
    x = 0:0.01:t0vec(end); % set up the contour plot with the mesh grid
    y = 0:0.01:tauvec(end);
    [X, Y] = meshgrid(x, y); % below is the equation contour
    Zb = ((1 - (a_m./(1 + exp(-D* (-c_m + (f.*(X)./((f.*(X))+(g.*(Y))))))))).^2).* (-f_m.* (f.*(X)./((f.*(X))+(g.*(Y)))) + B_max) - (1 - (a_r./(1 + exp(-D* (-c_r+ (1./(1 + g.*(Y)))))))).* (1 - (a_r./(1 + exp(-D* (-c_r+ (f.*(X)./((f.*(X))+(g.*(Y))))))))).* (-f_r* (1./(1 + g.*(Y))) + B_max);
colormap(flipud(gray))

fs1 = 9;  % axes labels
fs3 = 9;  % axis numbering
lw2 = 1; % fig edges
lw1 = 1.5; % fig edges

sx = 0.1;
sy = 0.3;
w1 = 0.15;
he = 0.6;
delx = 0.06;

figure(1); clf
hh = gcf;
set(hh,'PaperUnits','centimeters');
set(hh,'Units','centimeters');
width = 17.3; height = 5;
xpos = 5;
ypos = 4;
set(gcf,'Position',[xpos ypos width height])



axes('position',[sx sy w1 he])
    imagesc(t0vec, tauvec, M5)
    set(gca, 'YDir', 'normal')
    hold on
    contour(X, Y, Zb, [0, 0],'linecolor', 'k','LineWidth',lw1) % add the contour on top
    hold off;
    set(gca,'XTick',[0.01 0.51 0.96])
    set(gca,'FontSize',fs3,'LineWidth',lw2,'Fontname', 'Arial');

axes('position',[sx+delx+w1 sy w1 he])
    imagesc(t0vec, tauvec, M7)
    set(gca, 'YDir', 'normal')
    hold on
    contour(X, Y, Zb, [0, 0],'linecolor', 'k','LineWidth',lw1) % add the contour on top
    hold off;
    set(gca,'XTick',[0.01 0.51 0.96])
    set(gca,'FontSize',fs3,'LineWidth',lw2,'Fontname', 'Arial');

axes('position',[sx+2*(delx+w1) sy w1 he])
    imagesc(t0vec, tauvec, M9)
    set(gca, 'YDir', 'normal')
    hold on
    contour(X, Y, Zb, [0, 0],'linecolor', 'k','LineWidth',lw1) % add the contour on top
    hold off;
    set(gca,'XTick',[0.01 0.51 0.96])
    set(gca,'FontSize',fs3,'LineWidth',lw2,'Fontname', 'Arial');

axes('position',[sx+3*(delx+w1) sy w1 he])
    imagesc(t0vec, tauvec, M12)
    set(gca, 'YDir', 'normal')
    hold on
    contour(X, Y, Zb, [0, 0],'linecolor', 'k','LineWidth',lw1) % add the contour on top
    hold off;
    set(gca,'XTick',[0.01 0.51 0.96])
    set(gca,'FontSize',fs3,'LineWidth',lw2,'Fontname', 'Arial');

    % add colorbar by hand
axes('position',[sx+4*(delx+w1)-0.01 sy 0.02 he])
    imagesc([64:-1:1]')
    set(gca,'XTick',[])
    set(gca,'YTick',[])

    
% labels
axes('position',[0 0 1 1],'visible','off')
hold on
     text(0.06,0.96,'a)','fontsize',fs3)
     text(0.06+delx+w1,0.96,'b)','fontsize',fs3)
     text(0.06+2*(delx+w1),0.96,'c)','fontsize',fs3)
     text(0.06+3*(delx+w1),0.96,'d)','fontsize',fs3)

     text(0.02,0.6,'half-intensity time (\tau_h)','horizontalalignment','center','rotation',90)
     text(0.04,0.85,'slow','horizontalalignment','center','rotation',90)
     text(0.04,0.32,'fast','horizontalalignment','center','rotation',90)

%     text(0.16,0.16,'early','horizontalalignment','center')
%     text(0.32,0.16,'late','horizontalalignment','center')
     text(0.5,0.05,'migration point (t_0)','horizontalalignment','center')
     
    text(0.96,0.93,'1','fontsize',fs3)
    text(0.96,0.82,'0.8','fontsize',fs3)
    text(0.96,0.67,'0.6','fontsize',fs3)
    text(0.96,0.53,'0.4','fontsize',fs3)
    text(0.96,0.4,'0.2','fontsize',fs3)
    text(0.96,0.28,'0','fontsize',fs3)
   

axis([0 1 0 1])


% Backup previous settings
prePaperType = get(hh,'PaperType');
prePaperPosition = get(hh,'PaperPosition');
prePaperSize = get(hh,'PaperSize');

% Make changing paper type possible
set(hh,'PaperType','<custom>');
% Set the page size and position to match the figure's dimensions
position = get(hh,'Position');
set(hh,'PaperPosition',[0,0,position(3:4)]);
set(hh,'PaperSize',position(3:4));

%saveas(1,strcat(['fig.jpg']))
%print -dpdf -r600 Figure.pdf
print -djpeg -r600 figS2.jpg

% Restore the previous settings
set(hh,'PaperType',prePaperType);
set(hh,'PaperPosition',prePaperPosition);
set(hh,'PaperSize',prePaperSize);
